/*
 * temperature.cpp
 *
 * Created: 30.01.2022 15:23:30
 *  Author: Kacper
 */ 
#include "temperature.h"

// Digital Sensor DS18B20
OneWire oneWire(A0); //Connected to A0
DallasTemperature sensors(&oneWire); //Set info to library

void setTemperatureSensors()
{
	sensors.begin(); //Initialize OneWire sensors
}

float readTemperature()
{
	sensors.requestTemperatures(); //Get temperature from sensors
	
	float temperature = sensors.getTempCByIndex(0); // Get value from first sensor
		
	return temperature;
}

void getTemperatureText(char* result)
{
	float temperatureValue = readTemperature();
		
	if(temperatureValue == -127)
	{
		strcat(result, "N_L"); // NO LINK
	}
	else if(temperatureValue > -50 && temperatureValue < 100)
	{
		dtostrf(0, 2, 0, result);
		
		bool belowZero = temperatureValue < 0;
			
		if(belowZero)
			temperatureValue = -temperatureValue;
			
		dtostrf(temperatureValue, 2, 0, result);
			
		strcat(result, belowZero ? "E":"C");
	}
	else
	{
		strcat(result, "W_V"); // Wrong Value
	}
}